/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/srv/head_ctrl.srv
 *
 */


#ifndef ROVIO_SHARED_MESSAGE_HEAD_CTRLREQUEST_H
#define ROVIO_SHARED_MESSAGE_HEAD_CTRLREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rovio_shared
{
template <class ContainerAllocator>
struct head_ctrlRequest_
{
  typedef head_ctrlRequest_<ContainerAllocator> Type;

  head_ctrlRequest_()
    : head_pos(0)  {
    }
  head_ctrlRequest_(const ContainerAllocator& _alloc)
    : head_pos(0)  {
    }



   typedef int8_t _head_pos_type;
  _head_pos_type head_pos;


    enum { HEAD_UP = 11 };
     enum { HEAD_DOWN = 12 };
     enum { HEAD_MIDDLE = 13 };
 

  typedef boost::shared_ptr< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct head_ctrlRequest_

typedef ::rovio_shared::head_ctrlRequest_<std::allocator<void> > head_ctrlRequest;

typedef boost::shared_ptr< ::rovio_shared::head_ctrlRequest > head_ctrlRequestPtr;
typedef boost::shared_ptr< ::rovio_shared::head_ctrlRequest const> head_ctrlRequestConstPtr;

// constants requiring out of line definition

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rovio_shared::head_ctrlRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rovio_shared

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rovio_shared': ['/tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "522f8591c845ace5ac8c5c5852170802";
  }

  static const char* value(const ::rovio_shared::head_ctrlRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x522f8591c845ace5ULL;
  static const uint64_t static_value2 = 0xac8c5c5852170802ULL;
};

template<class ContainerAllocator>
struct DataType< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rovio_shared/head_ctrlRequest";
  }

  static const char* value(const ::rovio_shared::head_ctrlRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
int8 HEAD_UP=11\n\
int8 HEAD_DOWN=12\n\
int8 HEAD_MIDDLE=13\n\
\n\
int8 head_pos\n\
";
  }

  static const char* value(const ::rovio_shared::head_ctrlRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.head_pos);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct head_ctrlRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rovio_shared::head_ctrlRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rovio_shared::head_ctrlRequest_<ContainerAllocator>& v)
  {
    s << indent << "head_pos: ";
    Printer<int8_t>::stream(s, indent + "  ", v.head_pos);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROVIO_SHARED_MESSAGE_HEAD_CTRLREQUEST_H
