/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/srv/head_ctrl.srv
 *
 */


#ifndef ROVIO_SHARED_MESSAGE_HEAD_CTRLRESPONSE_H
#define ROVIO_SHARED_MESSAGE_HEAD_CTRLRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rovio_shared
{
template <class ContainerAllocator>
struct head_ctrlResponse_
{
  typedef head_ctrlResponse_<ContainerAllocator> Type;

  head_ctrlResponse_()
    : response(0)  {
    }
  head_ctrlResponse_(const ContainerAllocator& _alloc)
    : response(0)  {
    }



   typedef int8_t _response_type;
  _response_type response;


    enum { SUCCESS = 0 };
     enum { FAILURE = 1 };
     enum { ROBOT_BUSY = 2 };
     enum { FEATURE_NOT_IMPLEMENTED = 3 };
     enum { UNKNOWN_CGI_ACTION = 4 };
     enum { NO_NS_SIGNAL = 5 };
     enum { NO_EMPTY_PATH_AVAILABLE = 6 };
     enum { FAILED_TO_READ_PATH = 7 };
     enum { PATH_BASEADDRESS_NOT_INITIALIZED = 8 };
     enum { PATH_NOT_FOUND = 9 };
     enum { PATH_NAME_NOT_SPECIFIED = 10 };
     enum { NOT_RECORDING_PATH = 11 };
     enum { FLASH_NOT_INITIALIZED = 12 };
     enum { FAILED_TO_DELETE_PATH = 13 };
     enum { FAILED_TO_READ_FROM_FLASH = 14 };
     enum { FAILED_TO_WRITE_TO_FLASH = 15 };
     enum { FLASH_NOT_READY = 16 };
     enum { NO_MEMORY_AVAILABLE = 17 };
     enum { NO_MCU_PORT_AVAILABLE = 18 };
     enum { NO_NS_PORT_AVAILABLE = 19 };
     enum { NS_PACKET_CHECKSUM_ERROR = 20 };
     enum { NS_UART_READ_ERROR = 21 };
     enum { PARAMETER_OUTOFRANGE = 22 };
     enum { NO_PARAMETER = 23 };
 

  typedef boost::shared_ptr< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct head_ctrlResponse_

typedef ::rovio_shared::head_ctrlResponse_<std::allocator<void> > head_ctrlResponse;

typedef boost::shared_ptr< ::rovio_shared::head_ctrlResponse > head_ctrlResponsePtr;
typedef boost::shared_ptr< ::rovio_shared::head_ctrlResponse const> head_ctrlResponseConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rovio_shared::head_ctrlResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rovio_shared

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rovio_shared': ['/tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "208ac5fdc497ef2f1bd168d28a2b5e05";
  }

  static const char* value(const ::rovio_shared::head_ctrlResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x208ac5fdc497ef2fULL;
  static const uint64_t static_value2 = 0x1bd168d28a2b5e05ULL;
};

template<class ContainerAllocator>
struct DataType< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rovio_shared/head_ctrlResponse";
  }

  static const char* value(const ::rovio_shared::head_ctrlResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
int8 SUCCESS=0\n\
int8 FAILURE=1\n\
int8 ROBOT_BUSY=2\n\
int8 FEATURE_NOT_IMPLEMENTED=3\n\
int8 UNKNOWN_CGI_ACTION=4\n\
int8 NO_NS_SIGNAL=5\n\
int8 NO_EMPTY_PATH_AVAILABLE=6\n\
int8 FAILED_TO_READ_PATH=7\n\
int8 PATH_BASEADDRESS_NOT_INITIALIZED=8\n\
int8 PATH_NOT_FOUND=9\n\
int8 PATH_NAME_NOT_SPECIFIED=10\n\
int8 NOT_RECORDING_PATH=11\n\
int8 FLASH_NOT_INITIALIZED=12\n\
int8 FAILED_TO_DELETE_PATH=13\n\
int8 FAILED_TO_READ_FROM_FLASH=14\n\
int8 FAILED_TO_WRITE_TO_FLASH=15\n\
int8 FLASH_NOT_READY=16\n\
int8 NO_MEMORY_AVAILABLE=17\n\
int8 NO_MCU_PORT_AVAILABLE=18\n\
int8 NO_NS_PORT_AVAILABLE=19\n\
int8 NS_PACKET_CHECKSUM_ERROR=20\n\
int8 NS_UART_READ_ERROR=21\n\
int8 PARAMETER_OUTOFRANGE=22\n\
int8 NO_PARAMETER=23\n\
\n\
int8 response\n\
\n\
";
  }

  static const char* value(const ::rovio_shared::head_ctrlResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.response);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct head_ctrlResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rovio_shared::head_ctrlResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rovio_shared::head_ctrlResponse_<ContainerAllocator>& v)
  {
    s << indent << "response: ";
    Printer<int8_t>::stream(s, indent + "  ", v.response);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROVIO_SHARED_MESSAGE_HEAD_CTRLRESPONSE_H
