/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/msg/man_drv.msg
 *
 */


#ifndef ROVIO_SHARED_MESSAGE_MAN_DRV_H
#define ROVIO_SHARED_MESSAGE_MAN_DRV_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rovio_shared
{
template <class ContainerAllocator>
struct man_drv_
{
  typedef man_drv_<ContainerAllocator> Type;

  man_drv_()
    : drive(0)
    , speed(0)  {
    }
  man_drv_(const ContainerAllocator& _alloc)
    : drive(0)
    , speed(0)  {
    }



   typedef int8_t _drive_type;
  _drive_type drive;

   typedef int8_t _speed_type;
  _speed_type speed;


    enum { STOP = 0 };
     enum { FORWARD = 1 };
     enum { BACKWARD = 2 };
     enum { STRAIGHT_LEFT = 3 };
     enum { STRAIGHT_RIGHT = 4 };
     enum { ROTATE_LEFT = 5 };
     enum { ROTATE_RIGHT = 6 };
     enum { DIAGONAL_FORWARD_LEFT = 7 };
     enum { DIAGONAL_FORWARD_RIGHT = 8 };
     enum { DIAGONAL_BACKWARD_LEFT = 9 };
     enum { DIAGONAL_BACKWARD_RIGHT = 10 };
     enum { HEAD_UP = 11 };
     enum { HEAD_DOWN = 12 };
     enum { HEAD_MIDDLE = 13 };
     enum { ROTATE_LEFT_20_DEG = 17 };
     enum { ROTATE_RIGHT_20_DEG = 18 };
     enum { MIN_DRIVE_VAL = 0 };
     enum { MAX_DRIVE_VAL = 18 };
     enum { FASTEST = 1 };
     enum { SLOWEST = 10 };
     enum { MIN_SPEED_VAL = 1 };
     enum { MAX_SPEED_VAL = 10 };
 

  typedef boost::shared_ptr< ::rovio_shared::man_drv_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rovio_shared::man_drv_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct man_drv_

typedef ::rovio_shared::man_drv_<std::allocator<void> > man_drv;

typedef boost::shared_ptr< ::rovio_shared::man_drv > man_drvPtr;
typedef boost::shared_ptr< ::rovio_shared::man_drv const> man_drvConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rovio_shared::man_drv_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rovio_shared::man_drv_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rovio_shared

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rovio_shared': ['/tmp/buildd/ros-groovy-rovio-shared-0.2.1-0oneiric-20140906-0029/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::man_drv_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rovio_shared::man_drv_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::man_drv_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rovio_shared::man_drv_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::man_drv_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rovio_shared::man_drv_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rovio_shared::man_drv_<ContainerAllocator> >
{
  static const char* value()
  {
    return "14675853bd9417686a1390c3fb2eaae6";
  }

  static const char* value(const ::rovio_shared::man_drv_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x14675853bd941768ULL;
  static const uint64_t static_value2 = 0x6a1390c3fb2eaae6ULL;
};

template<class ContainerAllocator>
struct DataType< ::rovio_shared::man_drv_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rovio_shared/man_drv";
  }

  static const char* value(const ::rovio_shared::man_drv_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rovio_shared::man_drv_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Constants for the 'drive' value as defined by the Rovio API\n\
int8 STOP=0\n\
int8 FORWARD=1\n\
int8 BACKWARD=2 \n\
int8 STRAIGHT_LEFT=3\n\
int8 STRAIGHT_RIGHT=4\n\
int8 ROTATE_LEFT=5\n\
int8 ROTATE_RIGHT=6\n\
int8 DIAGONAL_FORWARD_LEFT=7\n\
int8 DIAGONAL_FORWARD_RIGHT=8\n\
int8 DIAGONAL_BACKWARD_LEFT=9\n\
int8 DIAGONAL_BACKWARD_RIGHT=10\n\
int8 HEAD_UP=11\n\
int8 HEAD_DOWN=12\n\
int8 HEAD_MIDDLE=13\n\
# 14, 15, and 16 are reserved values\n\
int8 ROTATE_LEFT_20_DEG=17\n\
int8 ROTATE_RIGHT_20_DEG=18\n\
int8 MIN_DRIVE_VAL=0\n\
int8 MAX_DRIVE_VAL=18\n\
\n\
# Constants useful for the 'speed' value as defined by the Rovio API\n\
int8 FASTEST=1 \n\
int8 SLOWEST=10\n\
int8 MIN_SPEED_VAL=1\n\
int8 MAX_SPEED_VAL=10\n\
\n\
# The manual drive message contains a 'drive' and 'speed' value as defined by the Rovio API\n\
int8 drive\n\
int8 speed\n\
";
  }

  static const char* value(const ::rovio_shared::man_drv_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rovio_shared::man_drv_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.drive);
      stream.next(m.speed);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct man_drv_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rovio_shared::man_drv_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rovio_shared::man_drv_<ContainerAllocator>& v)
  {
    s << indent << "drive: ";
    Printer<int8_t>::stream(s, indent + "  ", v.drive);
    s << indent << "speed: ";
    Printer<int8_t>::stream(s, indent + "  ", v.speed);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROVIO_SHARED_MESSAGE_MAN_DRV_H
